/* $Id: card.h,v 1.1.1.1 1999/01/30 06:09:06 andrewk Exp $
 ******************************************************************************
 * 
 * piocons - PSX PIO console utility for linux
 * Copyright (C) 1997,1998 by "The PIOCONS Team" (see AUTHORS)
 * All Rights Reserved.
 * 
 ******************************************************************************
 */

#ifndef __CARD_H__
#define __CARD_H__

#include "defs.h"

#define CARD_MAX_COUNT 16

typedef struct {
	u_short p1;					// ???
	u_long size;				// file size in bytes
	u_short p2;					// ???
	char name[20];				// file name
	u_short p3;					// ???
	u_short p4;					// ???
	u_short p5;					// ???
	char comment[94];			// sjis encoded kanji comment.
} card_entry_t;

typedef struct {
	u_short count;							// number of valid entries. 0=empty.
	card_entry_t entry[CARD_MAX_COUNT];		// max number of entries.
} card_list_t;

enum {
	MCOP_BACKUP,
	MCOP_RESTORE,
	MCOP_LIST,
	MCOP_DELETE,
	MCOP_FORMAT,
};

/** prototypes **/

void card_operation (u_short slot, u_short opcode, char *filename);
char *card_name_of_op (u_short opcode);

#endif  __CARD_H__
