/* $Id: ezoray.c,v 1.1.1.1 1999/01/30 06:09:06 andrewk Exp $
 ******************************************************************************
 * 
 * piocons - PSX PIO console utility for linux
 * Copyright (C) 1997,1998 by "The PIOCONS Team" (see AUTHORS)
 * All Rights Reserved.
 * 
 ******************************************************************************


	this is a very simple module. if someone wants to finish it, feel free
	to do it. ez-o-ray has not the quality of caetla, I'm using caetla.

 */

#include "rom.h"
#include "error.h"

enum
{
	EZORAY_NONE,
	EZORAY_UPLOAD,		// psx -> pc
	EZORAY_02,
	EZORAY_SET_CHEAT,
	EZORAY_04,
	EZORAY_05,
	EZORAY_06,
	EZORAY_STATUS,
	EZORAY_PATCH_UCHAR,
	EZORAY_DOWNLOAD,	// pc -> psx
	EZORAY_EXECUTE,
	EZORAY_GET_REGS,
	EZORAY_BREAKPOINT,
	EZORAY_RESUME,
	EZORAY_SET_REG,
	EZORAY_0F,
	EZORAY_10,
	EZORAY_PATCH_ULONG,
	EZORAY_UPLOAD_VRAM,
	EZORAY_DOWNLOAD_VRAM,
	EZORAY_JUMP
};

static void ezoray_command (u_char command)
{
	u_char x;
	int i=0;

	while (i<10000)
	{
		x = rom_swap_8('i');
		if (x == 'd') break;
	}
	if (i==10000) errorf ("ezoray protocol error\n");

	x = rom_swap_8('n');
	if (x != 'o') errorf ("ezoray protocol error\n");

	x = rom_swap_8 (command);
	if (x != 0) errorf ("ezoray protocol error\n");
}

static bool ezoray_detect (void)
{
	u_char x;
	int i=0;

	while (i<10000)
	{
		x = rom_swap_8('i');
		if (rom_error) return FALSE;
		if (x == 'd') break;
	}
	if (i==10000) return FALSE;

	x = rom_swap_8('n');
	if (rom_error) return FALSE;
	if (x != 'o') return FALSE;

	x = rom_swap_8 (EZORAY_RESUME);
	if (rom_error) return FALSE;
	if (x != 0) return FALSE;

//	return TRUE;
	return FALSE;
}

static void ezoray_reset (void)
{
	// not necessary.
}

static void ezoray_boot (char *filename, ps_env_t *e, bool console)
{
}

static void ezoray_send_memory (u_long address, u_char *buffer, u_long size)
{
	ezoray_command (EZORAY_DOWNLOAD);
	rom_swap_32 (address);
	rom_swap_32 (size);
//	SendAndCheck(tExec0C50?1:0,0);
	rom_swap_8 (0);

	rom_send_memory (buffer,size);

	rom_swap_8 (0);
	ezoray_command (EZORAY_RESUME);
}

static void ezoray_recv_memory (u_long address, u_char *buffer, u_long size)
{
}

static void ezoray_send_vram (vram_image_t *image)
{
}

static void ezoray_recv_vram (vram_image_t *image)
{
}

static void ezoray_send_wave (u_long address, u_char *buffer, u_long size)
{
}

static void ezoray_recv_wave (u_long address, u_char *buffer, u_long size)
{
}

static void ezoray_go (ps_env_t *e, ps_header_t *h, bool console)
{
	ezoray_command (EZORAY_SET_REG);
	rom_swap_8 (29);
	rom_swap_32 (h->sp);
	rom_swap_8 (0);

	ezoray_command (EZORAY_SET_REG);
	rom_swap_8 (28);
	rom_swap_32 (h->gp0);
	rom_swap_8 (0);

	ezoray_command (EZORAY_JUMP);
	rom_swap_32 (h->pc0);
	rom_swap_8 (0);
}

static void ezoray_server (void)
{
}

static void ezoray_flash (u_char *buffer, u_long length)
{
	u_short chk;
	u_char x;
	u_char *p;
	int i;

	verbosef (VERBOSE_ALL,
	"FIRMWARE FLASHROM UPDATE. Switch PlayStation OFF and CTRL-C to abort!\n"
	"Press RESET on PlayStation if you want to update your flash ROM!\n"
	);

	while (rom_swap_8('W') != 'R');
	verbosef (VERBOSE_ALL,"Sending update program\n");
	while (rom_swap_8('B') != 'W');
	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8('X') != 'X');
	verbosef (VERBOSE_PROGRESS,".");
	rom_swap_32 (0x80020000);
	rom_swap_32 (4100);

	p = (u_char *) flasher_rom;
	chk = 0;
	for (i=0;i<4100;i++)
	{
		if ((i % 256)==0) verbosef (VERBOSE_PROGRESS,".");
		x = *p++;
		if (rom_swap_8 (x) != x) errorf("Transfer error!\n");
		chk += x;
	}
	rom_swap_16 ( chk & 0xfff );

	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8(0) != 'O');
	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8('W') != 'K');
	verbosef (VERBOSE_PROGRESS,".\n");

	verbosef (VERBOSE_ALL,"Sending ROM image\n");

	while (rom_swap_8('W') != 'R');
	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8('B') != 'W');
	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8('U') != 'U');
	verbosef (VERBOSE_PROGRESS,".");
	rom_swap_32 (0x80040000);
	rom_swap_32 (length);

	p = (u_char *) buffer;
	chk = 0;
	for (i=0;i<length;i++)
	{
		if ((i % 256)==0) verbosef (VERBOSE_PROGRESS,".");
		x = *p++;
		if (rom_swap_8 (x) != x) errorf("Transfer error!\n");
		chk += x;
	}
	rom_swap_16 ( chk & 0xfff );

	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8(0) != 'O');
	verbosef (VERBOSE_PROGRESS,".");
	while (rom_swap_8('W') != 'K');
	verbosef (VERBOSE_PROGRESS,".\n");

	verbosef (VERBOSE_ALL,"Update complete.\n");
}

rom_module_t ezoray_rom = {
	NULL,
	
	// module informations	
	"EZORAY",
	"0.2",
	"ezoray rom driver",
	"The PIOCONS Team",
	#include "AUTHORS"

	,0x0,

	ezoray_detect,
	ezoray_reset,
	NULL, //ezoray_boot,
	ezoray_send_memory,
	NULL, //ezoray_recv_memory,
	NULL, //ezoray_send_vram,
	NULL, //ezoray_recv_vram,
	NULL, //ezoray_send_wave,
	NULL, //ezoray_recv_wave,
	ezoray_go,
	NULL, //ezoray_call
	NULL, //ezoray_server,
	ezoray_flash,
	NULL, // card_on
	NULL, // card_off
	NULL, // card_list
	NULL, // card_download,
	NULL, // card_upload,
};
